package GUI2;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;

import VM2.*;

public class mainFormSwing extends JFrame implements ActionListener,
		MouseListener, ItemListener {
	
	private Timer myTimer; 
	private JPB myJPB;
	private Image image; 
	private File theFile;
	private String fileName;
	private String pathName;
	private int frameRate = 100; 
	private JCheckBox imageType;
	private JTextField imageName;
	private JButton imageButton;
	private String ipText;
	private String portText;
	private JComboBox commSelSys;
	private JList commands;
	private String txtReg;
	private String txtData;
	private JComboBox commSelUsr;
	private JList usrCommands;
	private String txtUser1;
	private String txtUser2;
	private String txtUser3;
	private String txtUser4;
	private String txtUser5;
	private JButton browse;
	private JButton delete;
	private JButton runCam;
	private JLabel heartBeat;
	private JLabel status;
	private Canvas imgCanvas;

	final private int GAP = 5;
	private JButton playButton;
	private JButton stopButton;
	private boolean drawable;
	private int[] sensor1 = new int[] {-1,-1,-1,-1,-1,-1,-1,-1};

	public static void main(String[] args) {
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (Exception e) {
			e.printStackTrace();
		}
		new mainFormSwing();
	}

	public mainFormSwing() {
		initialize();
		getContentPane().setLayout(new BorderLayout(GAP, GAP));

		JPanel imagePanel = new JPanel(new BorderLayout(GAP, GAP));
		JPanel commandPanel = new JPanel(new GridLayout(1, 2, GAP, GAP));
		JPanel settingPanel = new JPanel(new GridLayout(2, 1, GAP, GAP));

		getContentPane().add(imagePanel, BorderLayout.CENTER);
		getContentPane().add(commandPanel, BorderLayout.EAST);
		//getContentPane().add(settingPanel, BorderLayout.SOUTH);

		JPanel imageControlPanel = new JPanel(new BorderLayout(GAP, GAP));
		JPanel canvasPanel = new JPanel(new BorderLayout(GAP, GAP));
		JPanel actionPanel = new JPanel(new BorderLayout(GAP, GAP));
		imagePanel.add(imageControlPanel, BorderLayout.NORTH);
		imagePanel.add(canvasPanel, BorderLayout.CENTER);
		imagePanel.add(actionPanel, BorderLayout.SOUTH);

		// imageControlPanel
		JPanel imageTypePanel = new JPanel(new BorderLayout(GAP, GAP));
		imageTypePanel.add(new JLabel("Pic:"), BorderLayout.WEST);
		imageTypePanel.add(imageType = new JCheckBox("", true),
				BorderLayout.CENTER);
		imageControlPanel.add(imageTypePanel, BorderLayout.WEST);
		imageControlPanel.add(imageName = new JTextField("test.raw"),
				BorderLayout.CENTER);
		imageControlPanel.add(imageButton = new JButton("..."),
				BorderLayout.EAST);

		// canvasPanel
		canvasPanel.setBorder(BorderFactory.createLoweredBevelBorder());
		canvasPanel.add(imgCanvas = new Canvas() {
			// Overriding update(g) as well removes flicker We don't need
			// to erase the background, we always draw an entire image
			public void update(Graphics g) {
				paint(g);
			}

			public void paint(Graphics g) {
				g.drawImage(image, 0, 0, this);
			}
		}, BorderLayout.CENTER);
		canvasPanel.setPreferredSize(new Dimension(356
				+ canvasPanel.getInsets().left + canvasPanel.getInsets().right,
				292 + canvasPanel.getInsets().top
						+ canvasPanel.getInsets().bottom));

		ipText = "192.168.100.14";
		portText = "6363";

		//actionPanel
		playButton = new JButton("play");
		playButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				execUserCommand("43-start");
			}
		});
		stopButton = new JButton("stop");
		stopButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				execUserCommand("46-stop");
			}
		});
		actionPanel.add(playButton, BorderLayout.WEST);
		actionPanel.add(stopButton, BorderLayout.EAST);

		//////////////////
		// commandPanel //
		//////////////////
		JPanel commPanel = new JPanel(new BorderLayout(GAP, GAP));
		JPanel userPanel = new JPanel(new BorderLayout(GAP, GAP));
		commandPanel.add(commPanel);
		commandPanel.add(userPanel);

		// commPanel
		JPanel commCameraPanel = new JPanel(new BorderLayout(GAP, GAP));
		commCameraPanel.add(new JLabel("Comm:"), BorderLayout.WEST);
		commCameraPanel.add(commSelSys = new JComboBox(new String[] { "Socket",
				"Local", "USB" }));
		commSelSys.setSelectedIndex(2);

		//JPanel regDataPanel = new JPanel(new BorderLayout(GAP,GAP));
		JPanel regDataLabelPanel = new JPanel(new GridLayout(2, 1, GAP, GAP));
		JPanel regDataTextPanel = new JPanel(new GridLayout(2, 1, GAP, GAP));

		txtReg = "0x12";
		txtData = "0x74";

		commPanel.add(commCameraPanel, BorderLayout.NORTH);
		commPanel.add(new JScrollPane(commands = new JList(new String[] {
		"1-Reset", "2-Stream", "3-Stop" }),
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
				JScrollPane.HORIZONTAL_SCROLLBAR_NEVER), BorderLayout.CENTER);

		// userPanel
		JPanel userCameraPanel = new JPanel(new BorderLayout(GAP, GAP));
		userCameraPanel.add(new JLabel("User:"), BorderLayout.WEST);
		userCameraPanel.add(commSelUsr = new JComboBox(new String[] { "Socket",
				"Local" }));
		commSelUsr.setSelectedIndex(1);

		JPanel userOperandPanel = new JPanel(new BorderLayout(GAP, GAP));
		JPanel userOperandLabelPanel = new JPanel(
				new GridLayout(5, 1, GAP, GAP));
		JPanel userOperandTextPanel = new JPanel(new GridLayout(5, 1, GAP, GAP));
		
		txtUser1 = "0x01";
		txtUser2 = "0x02";

		userPanel.add(userCameraPanel, BorderLayout.NORTH);
		userPanel.add(new JScrollPane(usrCommands = new JList(new String[] {
							"01-People Count", 
							"03-Optical flow2",
							"04-RGB", 
							"05-nRGB", 
							"06-c1c2c3", 
							"07-l1l2l3", 
							"47-HSI",
							"08-Background subtraction",
							"09-Optical flow1",
							"41-Closing",
							"42-Closing:Opening",
							"44-Region growing\\motion detection",
							"02-People Counting vertical",
							"45-People Counting horizontal"}
							),
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
				JScrollPane.HORIZONTAL_SCROLLBAR_NEVER), BorderLayout.CENTER);

		// settingPanel
		JPanel settingBarPanel = new JPanel(new BorderLayout(GAP, GAP));
		settingPanel.add(settingBarPanel);
		settingPanel.add(status = new JLabel());
		status.setBorder(BorderFactory.createLoweredBevelBorder());

		//to remove null pointers
		runCam = new JButton("Run...");
		heartBeat = new JLabel("   ");
		browse = new JButton("Settings...");
		delete = new JButton();
		
		//register event handlers
		commSelSys.addActionListener(this); // camera selection
		commSelUsr.addActionListener(this); // user selection
		commands.addMouseListener(this); // camera commands
		usrCommands.addMouseListener(this); // user commands
		imageType.addItemListener(this); // Picture or data selection
		imageButton.addActionListener(this); // Open image
		browse.addActionListener(this);
		delete.addActionListener(this);
		runCam.addActionListener(this);

		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				myJPB.stop();
				System.exit(0);
			}
		});

		myTimer = new Timer(frameRate, this);
		myTimer.setRepeats(false); // The timer is restarted for every frame

		myJPB = new JPB();
		myJPB.start(ipText, portText, commSelSys
				.getSelectedItem().toString());
		// Initialize the image
		extImage(); 

		// show GUI
		pack();
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		setLocation((int) ((screenSize.getWidth() - getWidth()) / 2),
				(int) ((screenSize.getHeight() - getHeight()) / 2));
		show();
	}

	/**
	 * initialize the JFrame
	 */
	private void initialize() {
		this.setSize(704, 408);
		this.setTitle("Java Camera Tester");
	}

	/**
	 * Retrieve the command number from the description string
	 * @param cmd
	 * @return command
	 */
	private static byte getCommand(String cmd) {
		return Byte.parseByte(cmd.substring(0, cmd.indexOf("-")));
	}

	/**
	 * generic method to execute commands
	 * makes sure start and stop are automatically called
	 */
	private void execUserCommand() {
		String command = usrCommands.getSelectedValue().toString();
		execUserCommand("46-stop");
		execUserCommand(command);
		if ((command.compareTo("45-People Counting horizontal") != 0)&&(command.compareTo("02-People Counting vertical") != 0))
			execUserCommand("43-start");
		
	}

	/**
	 * method to execute given command
	 * @param s
	 * command to be executed
	 */
	private void execUserCommand(String s) {
		byte iCmd = (byte) (getCommand(s) + 0x40);
		
		InnerMouseListener iml = new InnerMouseListener(iCmd);
		
		if (iCmd == 109) { //109
			//select two sensors and give them with the functioncall
			imgCanvas.getGraphics().setColor(Color.BLACK);
			drawable = true;
			imgCanvas.addMouseListener(iml);
		} else if (iCmd == 66) { //109
			//select two sensors and give them with the functioncall
			imgCanvas.getGraphics().setColor(Color.BLACK);
			drawable = true;
			imgCanvas.addMouseListener(iml);
		} else { 
			processCommand(iCmd, iml);
		}
	}

	/**
	 * makes connection with the virtual machine and sends command
	 * @param iCmd command to be processed
	 * @param iml imagelistener to be removed after use
	 */
	private void processCommand(byte iCmd, MouseListener iml) {
		byte[] ret;
		String errStr;
		int code;
		String cmd = iCmd + "-";
		status.setText("Executing: " + cmd);
		System.out.println("Executing: " + cmd);
		
		if (cmd.equals("109-")) {
			ret = myJPB.getVm().executeCommand(iCmd, txtUser1,
					sensor1);
			imgCanvas.removeMouseListener(iml);

		} else if (cmd.equals("66-")) {
			ret = myJPB.getVm().executeCommand(iCmd, txtUser1,
					sensor1);
			imgCanvas.removeMouseListener(iml);
		} else {
			ret = myJPB.getVm().executeCommand(iCmd, txtUser1,
					txtUser2);
		}
		errStr = JPB.getErrCode(ret);
		status.setText(errStr);
		code = ret[0] & 0xFF;

		if (code == JPBvm.DATA_2) {
			txtUser1 = "0x" + JPB.toHex(ret[1]);
			txtUser2 = "0x" + JPB.toHex(ret[2]);
		}
		code = ret[0] & 0xFF;
	}

	/**
	 * @author mjmetter
	 * inner class to listen to actions on canvas
	 */
	private class InnerMouseListener implements MouseListener {
		byte iCmd;

		InnerMouseListener(byte iCmd) {
			this.iCmd = iCmd;
		}

		public void mouseClicked(MouseEvent e) {
		}

		public void mouseEntered(MouseEvent e) {
		}

		public void mouseExited(MouseEvent e) {
		}

		public void mouseReleased(MouseEvent e) {
			if (drawable) {
				if (sensor1[2]==-1) {
					sensor1[2] = e.getPoint().x;
					sensor1[3] = e.getPoint().y;
					System.out.println("To: " + e.getPoint());
				} else if (sensor1[6]==-1) {
					/*imgCanvas.getGraphics().fillRect(sensor1[0], sensor1[1],
					sensor1[2] - sensor1[0],
					sensor1[3] - sensor1[1]);
					imgCanvas.repaint();*/
					sensor1[6] = e.getPoint().x;
					sensor1[7] = e.getPoint().y;
					processCommand(iCmd, this);
					System.out.println("To: " + e.getPoint());
					sensor1 = new int[] {-1,-1,-1,-1,-1,-1,-1,-1};
				}
			}
		}

		public void mousePressed(MouseEvent e) {
			if (drawable)
				if (sensor1[0]==-1) {
					sensor1[0] = e.getPoint().x;
					sensor1[1] = e.getPoint().y;
					System.out.println("From: " + e.getPoint());
				} else if (sensor1[4]==-1) {
					sensor1[4] = e.getPoint().x;
					sensor1[5] = e.getPoint().y;
					System.out.println("From: " + e.getPoint());
				}
			
		}
	}

	/**
	 * execute commands from camera
	 */
	private void execCommand() {
		byte[] ret;
		int errCode;
		String errStr;
		int code;

		String cmd = commands.getSelectedValue().toString();
		status.setText("Executing: " + cmd);
		setHeartBeat(true);

		ret = myJPB.getVm().executeCommand(getCommand(cmd), txtReg,
				txtData);
		errStr = JPB.getErrCode(ret);
		status.setText(errStr);
		code = ret[0] & 0xFF;

		if (getCommand(cmd) == JPBvm.READ_REG)
			txtData = "0x" + JPB.toHex(ret[1]);

		if (code == LocalJPBvm.DATA_X)
			streamPicture(code);

		if (getCommand(cmd) == JPBvm.READ_FRAME)
			streamPicture(JPBvm.DATA_X);

		if (getCommand(cmd) == JPBvm.STREAM)
			streamPicture(JPBvm.DATA_X);
			execUserCommand("43-start");

		if (code == LocalJPBvm.DATA_1)
			resizePicture(ret[1]);

		setHeartBeat(false);
	}

	/**
	 * make sure the images from the camera are well positioned
	 */
	private void setImage() {
		int frameSize = myJPB.getVm().getFrameSize();
		int lineSize = myJPB.getVm().getLineSize();

		int[] sRGBbuffer = new int[frameSize * lineSize];
		byte[] pixels = myJPB.getVm().getBuffer();

		for (int y = 0; y < frameSize; y++) {
			for (int x = 0; x < lineSize; x++) {
				sRGBbuffer[y * lineSize + x] = 255 << 24 | // Alpha (opacity)
						(pixels[(y * lineSize + x) * 3 + 0] & 0xFF) << 16 | // Red
						(pixels[(y * lineSize + x) * 3 + 1] & 0xFF) << 8 | // Green
						(pixels[(y * lineSize + x) * 3 + 2] & 0xFF); // Blue
			}
		}
		image = createImage(new MemoryImageSource(lineSize, frameSize,
				sRGBbuffer, 0, lineSize));

		imgCanvas.repaint();
	}

	/**
	 * reinitialize image
	 * 
	 * The new int array is initialised to zeroes, so their alphas are zero too,
	 * giving a completely transparent image.
	 */
	public void extImage() {
		image = createImage(new MemoryImageSource(356, 292, new int[356 * 292],
				0, 356));
		imgCanvas.repaint();
	}

	/**
	 * Displays the current screen buffer in the selected format
	 * 
	 * TODO This next line is old code. new code must be written to display
	 * the buffer as numbers in a table
	 * else imgData.setText(myJPB.getVm().getScreenBuffer().toString());
	 */
	private void displayPicture() {
		if (imageType.isSelected())
			setImage();
	}

	private void streamPicture(int code) {
		byte[] ret;

		setHeartBeat(true);
		// stuur het READ command
		ret = myJPB.getVm().executeCommand((byte) JPBvm.READ, "", "");
		code = ret[0] & 0xFF;

		displayPicture();
		if (code == LocalJPBvm.DATA_OK) {
			// Continue streaming?
			myTimer.restart();
		}

		setHeartBeat(false);
	}

	private void resizePicture(int ret) {
		// Switch between CIF / QCIF
		Dimension mySize = getSize();
		switch (ret) {
		case 1:
			setSize((int) mySize.getWidth() - 176,
					(int) mySize.getHeight() - 144);
			break;
		case 2:
			setSize((int) mySize.getWidth() + 176,
					(int) mySize.getHeight() + 144);
			break;
		}
	}

	private void setHeartBeat(boolean on) {
		if (on)
			heartBeat.setBackground(Color.red);
		else
			heartBeat.setBackground(SystemColor.control);
		// TODO the heartbeat indicator doesn't seem to react. Wrong functions
		// calls? Maybe force a redraw?
		heartBeat.repaint();
	}

	private boolean openFile() {
		fileName = "";
		return openFile(true);
	}

	// This function only sets the variables from the FileChooser
	private boolean openFile(boolean out) {
		JFileChooser chooser = new JFileChooser();
		chooser.setSelectedFile(new File("test.raw"));

		int result;
		if (out)
			result = chooser.showSaveDialog(this);
		else
			result = chooser.showOpenDialog(this);

		if (result == JFileChooser.APPROVE_OPTION) {
			theFile = chooser.getSelectedFile();
			fileName = theFile.getName();
			pathName = theFile.getPath();
			imageName.setText(fileName);
		}
		return true;
	}

	public static byte[] writeToFile() {
		// TODO This function is a remainder from the old code. It should be
		// rewritten
		/*
		 * int I; LineBuffer aLine; if (openFile(true)) { try { FileOutputStream
		 * outFile= new FileOutputStream(theFile); for (I=0; I
		 * <JPB.BufO.frameSize; I++) { aLine = JPB.BufO.getLine(I);
		 * outFile.write(aLine.Buffer, 0, JPB.BufO.lineSize+3); }
		 * outFile.close(); } catch (Exception e) { System.out.println("Error
		 * during file write: " + e); return
		 * LocalJPBvm.retByte(LocalJPBvm.DATA_BAD); } }
		 */
		return new byte[] { (byte) JPBvm.DATA_OK };
	}

	public static byte[] readFromFile() {
		// TODO This function is a remainder from the old code. It might need to
		// be revised
		/*
		 * int I; LineBuffer aLine; byte[] linePix; int byteOffs=0; int
		 * lineSize; if (openFile(false)) { try { FileInputStream inFile= new
		 * FileInputStream(theFile); lineSize = JPB.BufO.lineSize; linePix = new
		 * byte[lineSize + 3]; for (I=0; I <JPB.BufO.frameSize; I++) { byteOffs =
		 * I * (lineSize + 3); inFile.read(linePix, 0, lineSize+3); aLine =
		 * LineBuffer.makeLine(linePix); JPB.BufO.addLine(aLine); }
		 * inFile.close(); displayPicture(); } catch (Exception e) {
		 * System.out.println("Error during file read: " + e); return
		 * LocalJPBvm.retByte(LocalJPBvm.DATA_BAD); } }
		 */
		return new byte[] { (byte) JPBvm.DATA_OK };
	}

	public byte[] streamToFile() {
		int I;
		LineBuffer aLine;
		if (openFile(true)) {
			try {
				FileOutputStream outFile = new FileOutputStream(theFile);
				// TODO This function is a remainder from the old code. It
				// should be rewritten
				//for (I=0; I<JPB.BufO.frameSize; I++)
				//{
				//	aLine = JPB.BufO.getLine(I);
				//	outFile.write(aLine.Buffer);
				//}
			} catch (Exception e) {
				System.out.println("Error during file stream: " + e);
				return new byte[] { (byte) JPBvm.DATA_BAD };
			}
		}
		return new byte[] { (byte) JPBvm.DATA_OK };
	}

	public byte[] streamFromFile() {
		if (openFile(false)) {
			try {
				// TODO This function is a remainder from the old code. It
				// should be rewritten
				FileInputStream inFile = new FileInputStream(theFile);
				//inFile.read(pixels);
				//extImage();
			} catch (Exception e) {
				System.out.println("Error during stream from file; " + e);
				return new byte[] { (byte) JPBvm.DATA_BAD };
			}
		}
		return new byte[] { (byte) JPBvm.DATA_OK };
	}

	/**
	 * all actionlisteners
	 */
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == myTimer) {
			// The timer tells us to get the next frame
			streamPicture(JPBvm.DATA_X);
		} else if (e.getSource() == commSelSys) // Camera Selection
		{
			String mode = commSelSys.getSelectedItem().toString();

			myJPB.stop(); // Halt and cleanup the current camera before starting
			// a new one
			myJPB.start(ipText, portText, mode);
			if (mode.equals("Local") || mode.equals("USB"))
				commSelUsr.setSelectedItem("Local");
		} else if (e.getSource() == commSelUsr) // User Selection
		{
			if (commSelSys.getSelectedItem().toString().equals("Local"))
				commSelUsr.setSelectedItem("Local");
		} else if (e.getSource() == imageButton) // Open file
		{
			openFile();
		} else if (e.getSource() == browse) // Browse file
		{
			JFileChooser chooser = new JFileChooser();
			if (chooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
				String fileName = new JFileChooser().getSelectedFile()
						.getName();
			}
		} else if (e.getSource() == delete) {
			extImage(); // Re-initialize the image
		} else if (e.getSource() == runCam) {
			System.out.println("\nDog Name: " + ipText);
			System.out.println("Dog Breed: "
					+ commSelSys.getSelectedItem().toString());
			System.out.println("Owner Name: " + ipText);
			System.out.println("Owner Phone: " + portText);
			System.out.println("Categories:");
			Object cats[] = commands.getSelectedValues();
			for (int i = 0; i < cats.length; i++) {
				System.out.println("\t" + cats[i]);
			}
		}
	}

	public void mousePressed(MouseEvent e) {
		if (e.getSource() == commands)
			execCommand();// Camera command
		else if (e.getSource() == usrCommands)
			execUserCommand(); // User command
	}

	public void itemStateChanged(ItemEvent e) {
		if (e.getSource() == imageType) // Picture or data select
		{
			if (imageType.isSelected()) {
				imgCanvas.setVisible(true);
				// TODO imgData is the textversion of the buffer, which should
				// be re-implemented
				//imgData.setVisible(false);
			} else {
				imgCanvas.setVisible(false);
				//imgData.setVisible(true);
			}
		}
	}

	// Unused functions form the mouselistener interface
	public void mouseClicked(MouseEvent e) {
	}

	public void mouseEntered(MouseEvent e) {
	}

	public void mouseExited(MouseEvent e) {
	}

	public void mouseReleased(MouseEvent e) {
	}

} //  @jve:decl-index=0:visual-constraint="10,10"
