/**
 * Created on 21-jan-2004
 * to alter the functions for the camera do the following:
 * 1. add or remove functions from the array in the main of MainFormSwing
 * 2. look for the appropiate hexadecimal code in the variables given here
 * 3. alter the appropiate functions in Dispatch in LocalJPBVM
 * 4. make sure the right function in UserTask is called
 */
package VM2;

public interface JPBvm
{
	public static final int Ver         = 0x03;
	public static final String Version  = "Version 0.3 - 12/01/04";
	public static final int ISTATUS     = 0x00; // 80	=Asks for slave status		->ABUSY/ALIVE
	public static final int RESET_JPB   = 0x01; // 40	=Resets the processor
	public static final int STREAM      = 0x02; // 80	=Reads continuous			->DATA
	public static final int STOP        = 0x03; // 80	=Stops reading  			->DATA
	public static final int READ_FRAME  = 0x05; // 80	=Reads a frame			 	->DATA
	public static final int COLORBAR    = 0x06; // 80	=Sets camera reg		 	->DATA
	public static final int IMAGE       = 0x07; // 80	=Sets camera reg		 	->DATA
	public static final int READ_REG    = 0x08; // 80	=Reads camera reg		 	->DATA
	public static final int SET_REG     = 0x09; // 80	=Sets camera reg		 	->DATA
	public static final int BW_COLOR    = 0x0B; // C0	=Sync input commands		->ALIVE
	public static final int WRITE_FILE  = 0x0C; // C0	=Sync input commands		->ALIVE
	public static final int READ_FILE   = 0x0D; // C0	=Sync input commands		->ALIVE
	public static final int IDENT       = 0x14; // C0	=Ask for identification		->ACK
	public static final int VER         = 0x2B; // C0	=Returns version code
	public static final int READ        = 0x2C; // C0	=Read next line
	public static final int ECHO        = 0x2D; // C1	=Echos a character
	public static final int SELF_TEST   = 0x2E; // C1  =Tests the functioning of the UPB
	public static final int ISYNC       = 0x2F; // C0	=Sync input commands		->ALIVE
	public static final int SET_CIF     = 0x30; // 40	=Resets the processor

	public static final int USR         = 0x40;
	public static final int USR_PEOPLE_COUNT  = 0x41;
	public static final int USR_TEST = 0x42;
	public static final int USR_RGB  = 0x44;
	public static final int USR_NRGB  = 0x45;
	public static final int USR_C1C2C3  = 0x46;
	public static final int USR_I1I2I3    = 0x47;
	public static final int USR_BACKGR_SUB  = 0x48;
	public static final int USR_OPTFLOW1    = 0x49;
	//public static final int USR_HSI     = 0x31;
	public static final int USR_F12     = 0x51;
	public static final int USR_F13     = 0x52;
	public static final int USR_F14     = 0x53;
	public static final int USR_F15     = 0x54;
	public static final int USR_F16     = 0x55;
	public static final int USR_F17     = 0x56;
	public static final int USR_F21     = 0x57;
	public static final int USR_F22     = 0x58;
	public static final int USR_F31     = 0x59;
	public static final int USR_CLOSING = 0x69;
	public static final int USR_OPENING = 0x6A;
	public static final int USR_START   = 0x6B;
	public static final int USR_BLUR	= 0x6C;
	public static final int USR_PC_HOR     = 0x6D;
	public static final int USR_PC_VER = 0x50;
	public static final int USR_STOP    = 0x6E;
	public static final int USR_HSI   = 0x6F;
	
	public static final int BYE         = 0xBB; // 00  =Stops the connection

	public static final int OPC_ZERO  = 0x00;
	public static final int OPC_ONE   = 0x01;
	public static final int OPC_TWO   = 0x02;
	public static final int OPC_VAR   = 0x03;
	public static final int OPC_VIA   = 0x40;
	public static final int OPC_REPLY = 0x80;
	public static final int OPC_MASK  = 0x03;

	public static final int[] CmdTable =
	{ISTATUS     , OPC_ZERO,
	 SELF_TEST   , OPC_ONE  + OPC_REPLY + OPC_VIA,
	 RESET_JPB   , OPC_ZERO             + OPC_VIA,
	 ISYNC       , OPC_ZERO + OPC_REPLY + OPC_VIA,
	 IDENT       , OPC_ZERO + OPC_REPLY + OPC_VIA,
	 SET_CIF     , OPC_ZERO             + OPC_VIA,
	 SET_REG     , OPC_TWO              + OPC_VIA,
	 READ_REG    , OPC_ONE  + OPC_REPLY + OPC_VIA,
	 READ_FRAME  , OPC_ONE  + OPC_REPLY + OPC_VIA,
	 READ        , OPC_ONE  + OPC_REPLY + OPC_VIA,
	 COLORBAR    , OPC_ZERO + OPC_REPLY + OPC_VIA,
	 IMAGE       , OPC_ZERO + OPC_REPLY + OPC_VIA,
	 BW_COLOR    , OPC_ZERO + OPC_REPLY + OPC_VIA,
	 STREAM      , OPC_ZERO + OPC_REPLY + OPC_VIA,
	 STOP        , OPC_ZERO             + OPC_VIA,
	 READ_FILE   , OPC_ZERO + OPC_REPLY,
	 WRITE_FILE  , OPC_ZERO + OPC_REPLY,
	 VER         , OPC_ZERO + OPC_REPLY + OPC_VIA,
	 ECHO        , OPC_ONE  + OPC_REPLY + OPC_VIA,
	 USR_START   , OPC_ZERO             + OPC_VIA,
	 USR_STOP    , OPC_ZERO             + OPC_VIA,
	 USR_HSI   , OPC_ZERO,
	 USR_RGB	, OPC_ZERO,
	 USR_NRGB  , OPC_ZERO,
	 USR_C1C2C3  , OPC_ZERO,
	 USR_I1I2I3    , OPC_ZERO,
	 USR_PEOPLE_COUNT  , OPC_ZERO,
	 USR_OPTFLOW1    , OPC_ZERO,
	 USR_CLOSING    , OPC_ZERO,
	 USR_OPENING    , OPC_ZERO,
	 USR_TEST , OPC_ZERO,
	 USR_BLUR	 , OPC_ZERO,
	 USR_HSI     , OPC_ZERO,
	 USR_PC_HOR, OPC_ZERO,
	 USR_PC_VER, OPC_ZERO,
	 USR_F12     , OPC_ZERO,
	 USR_F13     , OPC_ZERO,
	 USR_F14     , OPC_ZERO,
	 USR_F15     , OPC_ZERO,
	 USR_F16     , OPC_ZERO,
	 USR_F17     , OPC_ZERO,
	 USR_F21     , OPC_ZERO,
	 USR_F22     , OPC_ZERO,
	 USR_F31     , OPC_ZERO,
	 BYE         , OPC_ZERO
	};

	public static final int OK			= 0xE0;	// 00	=Operation OK
	public static final int DATA_0		= 0xE0;	// 00   =Data return mask
	public static final int DATA_1		= 0xE1;	// 00	=Return one byte
	public static final int DATA_2		= 0xE2;	// 00	=Return two bytes
	public static final int DATA_X		= 0xE3;	// 00	=Return variable bytes
	public static final int ILL_OPC		= 0xE4;	// 00	=Illegal opcode
	public static final int NOT_SUPP 	= 0xE5;	// 00	=Operation not supported
	public static final int WRT_OK		= 0xE6;	// 00	=Data was written OK
	public static final int WRT_ERR		= 0xE7;	// 00	=Data was not written OK
	public static final int DATA_OK		= 0xE8;	// 00	=Data sent has correct checksum
	public static final int DATA_BAD	= 0xE9;	// 00	=Data sent had incorrect checksum
	public static final int ALIVE		= 0xFA;	// 00	=System is alive, response to SYNC
	public static final int ACK			= 0xEB;	// 00	=Acknowledge IDENT
	public static final int TIMEOUT		= 0xEC;	// 00	=Timeout
	public static final int DONE		= 0xED;	// 00	=Processing is ready
	public static final int OVERFL		= 0xEF;	// 00	=Overflow in spi processing
	public static final int BUSY		= 0x0F;	// 00	=System is busy, response to unexpected command

	
	public byte[] executeCommand(byte cmd, String sReg, Object sData);
	
	public int getFrameSize();
	public int getLineSize();
	public byte[] getBuffer();	
	public CameraHandler getCamera();
	
	public void cleanup();
}