/*
 * Created on Jul 27, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package VM2;

import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetAddress;
import java.net.Socket;

public class SocketHandler extends Thread implements JPBvm
{
	private byte[] inBuffer;
	private byte[] outBuffer;
	private int BufLen= 0;
	private String hostIPAddress; // in dotted notation
	private String hostSocketPort; // a non-zero integer
	private InputStream in;
	private OutputStream out;
	private Socket theSocket;
	private LineBuffer aLine = new LineBuffer(0, 350);
	private int myFrameSize = 292;
	private int myLineSize = 356;

	private static final int maxPktSize= 400;

	public SocketHandler(String ipText, String portText)
	{
		outBuffer= new byte[3];
		inBuffer= new byte[360];
		BufLen= 0;
		hostIPAddress= ipText;
		hostSocketPort= portText;
		start();
		System.out.println("Started socket task");
	}
	
	public byte[] executeCommand(byte cmd, String sReg, String sData)
	{
		byte theCmd;
		byte theReg;
		byte theData;
		int[] theProps;
		int prop;
		theCmd= cmd;
		theReg=  Byte.decode(sReg).byteValue();
		theData= Byte.decode(sData).byteValue();
		theProps= getProps(theCmd);
		prop= theProps[2] & OPC_VIA;
		if (theCmd > USR)
		{
			return processCommand(theCmd, theReg, theData);
		}
		else
		{
			return processCommand(theCmd, theReg, theData);
		}
	}
	
	public static int[] getProps(int aCommand)
	{
		int prop;
		int I;
		int [] props = new int[3];
		for (I=0; I<CmdTable.length; I=I+2)
		{
			if (aCommand == CmdTable[I])
			{
				prop = CmdTable[I+1];
				props[0] = CmdTable[I];
				props[1] = prop & OPC_MASK;
				props[2] = prop & (OPC_REPLY ^ OPC_VIA);
				break;
			}
			props[0] = ILL_OPC;       // Generate illigal opcode
			props[1] = 0;
			props[2] = 0;
		}
		return props;
	}

	public void setBuffer(byte[] buffer)
	{
		//byteBuffer = buffer;	
	}
	
	public int bufSize()
	{
		return myFrameSize * myLineSize * 3;
	}
	
	public void run()
	{

		// String and objects for host IP address and port

		String maxMessageCount; 		// a non-zero integer
		String receiveTimeout; 			// a non-zero integer (milliseconds)

		InetAddress hostAddress;  	    // The IP address of the host running the server application
		int hostPortNumber=0;     		// The port number on the host that the server listens on
		int maxMessages=0;              // Number of messages to be sent to host
		int reportingInterval=0;   		// Number of messages allowed to pass before reporting
		int timeoutPeriod=0;      		// Number of milliseconds to wait for read() before announcing failure

		try
		{
			maxMessages= 10000000;
			timeoutPeriod= 1000;
			hostAddress= InetAddress.getByName(hostIPAddress);
			hostPortNumber= Integer.parseInt(hostSocketPort);
			reportingInterval= Math.max(1, maxMessages / 100);
			theSocket= new Socket(hostAddress, hostPortNumber);	
			
			System.out.print("Opened TCP Socket to IP address: ");
			System.out.print(hostIPAddress);
			System.out.print(" port number: ");
			System.out.println(hostSocketPort);
			
			System.out.print("Timeout on receive() set to ");
			System.out.print(timeoutPeriod);
			System.out.println(" milliseconds");
			
			System.out.print("Number of messages to be sent: ");
			System.out.println(maxMessages);
			
			out = theSocket.getOutputStream();
			in = theSocket.getInputStream();		
		}
		catch (Exception e)
		{
			System.out.println("Caught unexpected exception " + e);
		}
	}
	
	public byte[] processCommand(int cmd)
	{
		return processCommand((byte) cmd, (byte) 0,(byte) 0);
	}
	
	public byte[] processCommand(byte cmd, byte op1, byte op2)
	{
		int count;
		byte[] ret = new byte[2];
		int code;
		outBuffer[0]= cmd;
		outBuffer[1]= op1;
		outBuffer[2]= op2;
		try
		{
			out.write(outBuffer);           // Send the command
			if (cmd == LocalJPBvm.READ_FRAME || cmd == LocalJPBvm.READ || cmd == LocalJPBvm.STREAM)
			{
			    count = in.read(inBuffer);
				return inBuffer;
			}
			else
			{
				count= in.read(ret);
				if (cmd == LocalJPBvm.ISYNC)
				{
					code= ret[0] & 0xFF;
					while (code != LocalJPBvm.ALIVE)
					{
						out.write(outBuffer); // Repeat the sync command
						count= in.read(ret, 0, 1);
						code= ret[0] & 0xFF;
					}
				}
				return ret;
			}
		}
		catch (Exception e)
		{
			System.out.println("Error during processCommand: " + e.getMessage());
			return new byte[]{(byte)JPBvm.TIMEOUT};
		}
	}
	
	public int getFrameSize() {return myFrameSize;}
	public int getLineSize()  {return myLineSize;}
	
	public byte[] getBuffer()
	{
		return outBuffer;
	}
	
	public void cleanup()
	{
		// TODO clean things
	}
}
